Package com.xebialabs.xlrelease.builder

## Class VariableBuilder<V,​C extends Variable.VariableWithValue<V>>

- java.lang.Object
- - com.xebialabs.xlrelease.builder.VariableBuilder<V,​C>

-     public class VariableBuilder<V,​C extends Variable.VariableWithValue<V>>
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `VariableBuilder​(java.lang.Class<C> variableClass, java.lang.String key, V value)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `C` | `build()` |
    `VariableBuilder<V,​C>` | `isInherited​(boolean inherited)` |
    `static VariableBuilder<java.lang.Boolean,​BooleanVariable>` | `newBooleanVariable​(java.lang.String k, java.lang.Boolean v)` |
    `static VariableBuilder<java.util.Date,​DateVariable>` | `newDateVariable​(java.lang.String k, java.util.Date v)` |
    `static VariableBuilder<java.lang.String,​PasswordStringVariable>` | `newExternalPasswordVariable​(java.lang.String k, java.lang.String v)` |
    `static StringVariable` | `newGlobalVariable​(java.lang.String k, java.lang.String v)` |
    `static VariableBuilder<java.lang.Integer,​IntegerVariable>` | `newIntegerVariable​(java.lang.String k, java.lang.Integer v)` |
    `static VariableBuilder<java.util.List<java.lang.String>,​ListStringVariable>` | `newListStringVariable​(java.lang.String k, java.util.List<java.lang.String> v)` |
    `static VariableBuilder<java.util.Map<java.lang.String,​java.lang.String>,​MapStringStringVariable>` | `newMapStringStringVariable​(java.lang.String k, java.util.Map<java.lang.String,​java.lang.String> v)` |
    `static VariableBuilder<java.lang.String,​PasswordStringVariable>` | `newPasswordStringVariable​(java.lang.String k, java.lang.String v)` |
    `static VariableBuilder<java.lang.String,​ReferenceVariable>` | `newReferenceVariable​(java.lang.String k, java.lang.String v, java.lang.String referencedType)` |
    `static VariableBuilder<java.util.Set<java.lang.String>,​SetStringVariable>` | `newSetStringVariable​(java.lang.String k, java.util.Set<java.lang.String> v)` |
    `static VariableBuilder<java.lang.String,​StringVariable>` | `newStringVariable​(java.lang.String k, java.lang.String v)` |
    `static StringVariable` | `newVariable​(java.lang.String k, java.lang.String v)` |
    `VariableBuilder<V,​C>` | `withDescription​(java.lang.String description)` |
    `VariableBuilder<V,​C>` | `withExternalValue​(java.lang.String externalValue)` |
    `VariableBuilder<V,​C>` | `withFolderId​(java.lang.String folderId)` |
    `VariableBuilder<V,​C>` | `withId​(java.lang.String id)` |
    `VariableBuilder<V,​C>` | `withLabel​(java.lang.String label)` |
    `VariableBuilder<V,​C>` | `withPreventInterpolation​(boolean preventInterpolation)` |
    `VariableBuilder<V,​C>` | `withReferencedType​(java.lang.String referencedType)` |
    `VariableBuilder<V,​C>` | `withRequiresValue​(boolean value)` |
    `VariableBuilder<V,​C>` | `withShowOnReleaseStart​(boolean value)` |
    `VariableBuilder<V,​C>` | `withValueProvider​(ValueProviderConfiguration valueProvider)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### VariableBuilder

          public VariableBuilder​(java.lang.Class<C> variableClass,
                                 java.lang.String key,
                                 V value)

  - ### Method Detail

    - #### newVariable

          public static StringVariable newVariable​(java.lang.String k,
                                                   java.lang.String v)

    - #### newGlobalVariable

          public static StringVariable newGlobalVariable​(java.lang.String k,
                                                         java.lang.String v)

    - #### newStringVariable

          public static VariableBuilder<java.lang.String,​StringVariable> newStringVariable​(java.lang.String k,
                                                                                                 java.lang.String v)

    - #### newPasswordStringVariable

          public static VariableBuilder<java.lang.String,​PasswordStringVariable> newPasswordStringVariable​(java.lang.String k,
                                                                                                                 java.lang.String v)

    - #### newExternalPasswordVariable

          public static VariableBuilder<java.lang.String,​PasswordStringVariable> newExternalPasswordVariable​(java.lang.String k,
                                                                                                                   java.lang.String v)

    - #### newListStringVariable

          public static VariableBuilder<java.util.List<java.lang.String>,​ListStringVariable> newListStringVariable​(java.lang.String k,
                                                                                                                         java.util.List<java.lang.String> v)

    - #### newSetStringVariable

          public static VariableBuilder<java.util.Set<java.lang.String>,​SetStringVariable> newSetStringVariable​(java.lang.String k,
                                                                                                                      java.util.Set<java.lang.String> v)

    - #### newMapStringStringVariable

          public static VariableBuilder<java.util.Map<java.lang.String,​java.lang.String>,​MapStringStringVariable> newMapStringStringVariable​(java.lang.String k,
                                                                                                                                                         java.util.Map<java.lang.String,​java.lang.String> v)

    - #### newBooleanVariable

          public static VariableBuilder<java.lang.Boolean,​BooleanVariable> newBooleanVariable​(java.lang.String k,
                                                                                                    java.lang.Boolean v)

    - #### newIntegerVariable

          public static VariableBuilder<java.lang.Integer,​IntegerVariable> newIntegerVariable​(java.lang.String k,
                                                                                                    java.lang.Integer v)

    - #### newDateVariable

          public static VariableBuilder<java.util.Date,​DateVariable> newDateVariable​(java.lang.String k,
                                                                                           java.util.Date v)

    - #### newReferenceVariable

          public static VariableBuilder<java.lang.String,​ReferenceVariable> newReferenceVariable​(java.lang.String k,
                                                                                                       java.lang.String v,
                                                                                                       java.lang.String referencedType)

    - #### withId

          public VariableBuilder<V,​C> withId​(java.lang.String id)

    - #### withRequiresValue

          public VariableBuilder<V,​C> withRequiresValue​(boolean value)

    - #### withShowOnReleaseStart

          public VariableBuilder<V,​C> withShowOnReleaseStart​(boolean value)

    - #### withLabel

          public VariableBuilder<V,​C> withLabel​(java.lang.String label)

    - #### withFolderId

          public VariableBuilder<V,​C> withFolderId​(java.lang.String folderId)

    - #### withDescription

          public VariableBuilder<V,​C> withDescription​(java.lang.String description)

    - #### withValueProvider

          public VariableBuilder<V,​C> withValueProvider​(ValueProviderConfiguration valueProvider)

    - #### withExternalValue

          public VariableBuilder<V,​C> withExternalValue​(java.lang.String externalValue)

    - #### withPreventInterpolation

          public VariableBuilder<V,​C> withPreventInterpolation​(boolean preventInterpolation)

    - #### isInherited

          public VariableBuilder<V,​C> isInherited​(boolean inherited)

    - #### withReferencedType

          public VariableBuilder<V,​C> withReferencedType​(java.lang.String referencedType)

    - #### build

          public C build()